<?php

include_once __DIR__ . "/loader.php";
$microTimer = new microTimer();
$Filter = LazyDev\Filter\Filter::construct()->load($vars)->getVar()->getPage()->filterOptions()->order()->setUrl();
$url_page = $Filter::$urlFilter;
if ($vars["ajax"] && $configVar["ajax_form"]) {
    return NULL;
}
$filterID = $Filter::$urlFilter . "/";
if (1 < $Filter::$pageFilter) {
    $filterID .= "page/" . $Filter::$pageFilter . "/";
}
if (!$vars["ajax"]) {
    $homeUrl = LazyDev\Filter\Helper::cleanSlash($config["http_home_url"]);
    $_SERVER["REQUEST_URI"] = $homeUrl . rawurldecode($_SERVER["REQUEST_URI"]);
    $filterID = str_replace(array(" ", "%20"), "+", rawurldecode($filterID));
    if ($filterID != $_SERVER["REQUEST_URI"] || substr($_SERVER["REQUEST_URI"], -1, 1) != "/" || substr_count($_SERVER["REQUEST_URI"], "/page/1/")) {
        header("HTTP/1.0 301 Moved Permanently");
        header("Location: " . $filterID);
        exit("Redirect");
    }
}
$Conditions = LazyDev\Filter\Conditions::construct();
if ($configVar["cache_filter"]) {
    $cacheFilter = LazyDev\Filter\Cache::get($filterID);
    if ($cacheFilter) {
        $cacheFilter = json_decode($cacheFilter, true);
        if ($configVar["redirect_filter"] && !$vars["ajax"]) {
            $Filter::redirect($cacheFilter["countNews"]);
        }
        $tpl->result["content"] = $cacheFilter["content"];
        $tpl->result["navigation"] = $cacheFilter["navigation"];
        if (14 <= (double) $config["version_id"]) {
            $tpl->result["content"] = LazyDev\Filter\Filter::navigation();
        }
        $metatags["title"] = $cacheFilter["seo"]["title"] ?: $metatags["title"];
        $metatags["description"] = $cacheFilter["seo"]["description"] ?: $metatags["description"];
        $metatags["keywords"] = $cacheFilter["seo"]["keywords"] ?: $metatags["keywords"];
        $count_all = $cacheFilter["countNews"];
        $tpl->result["speedbar"] = $cacheFilter["seo"]["speedbar"];
        $metatags["keywords"] .= $Filter::metaRobots();
        if ($configVar["statistics"] && $Filter::$pageFilter < 2) {
            $Filter::setStatistics(array("mysqlTime" => -1, "templateTime" => -1, "foundNews" => $cacheFilter["foundNews"], "queryNumber" => -1, "statistics" => $cacheFilter["id"], "sqlQuery" => $db->safesql($cacheFilter["sqlQuery"])));
        }
        $config["speedbar"] = false;
        return NULL;
    }
}
if ($config["no_date"] && !$config["news_future"]) {
    $Filter::$sqlWhere[] = "date < '" . date("Y-m-d H:i:s", time()) . "'";
}
if (!$user_group[$member_id["user_group"]]["allow_short"]) {
    $notAllowedCat = explode(",", $user_group[$member_id["user_group"]]["not_allow_cats"]);
    if ($notAllowedCat[0]) {
        if ($config["allow_multi_category"]) {
            if (13.1 < $config["version_id"]) {
                $Filter::$sqlWhere[] = "p.id NOT IN (SELECT DISTINCT(" . PREFIX . "_post_extras_cats.news_id) FROM " . PREFIX . "_post_extras_cats WHERE cat_id IN (" . implode(",", $notAllowedCat) . "))";
            } else {
                if ($Filter::$oldMySQL) {
                    $Filter::$sqlWhere[] = "category NOT REGEXP '[[:<:]](" . implode("|", $notAllowedCat) . ")[[:>:]]'";
                } else {
                    $Filter::$sqlWhere[] = "category REGEXP '([[:punct:]]|^)(" . implode("|", $notAllowedCat) . ")([[:punct:]]|\$)'";
                }
            }
        } else {
            $Filter::$sqlWhere[] = "category NOT IN ('" . implode("','", $notAllowedCat) . "')";
        }
    }
}
if ($configVar["allow_main"]) {
    $Filter::$sqlWhere[] = "allow_main=1";
}
$filterSqlWhere = $Filter::$sqlWhere ? " AND " . implode(" AND ", $Filter::$sqlWhere) : "";
$allow_active_news = true;
$category_id = 999999;
$cat_info[$category_id]["short_tpl"] = "lazydev/dle_filter/news";
$sql_count = $Filter::sqlCount() . $filterSqlWhere;
$config["news_number"] = $configVar["news_number"] ?: $config["news_number"];
$cstart = $Filter::$pageFilter;
if ($cstart) {
    $cstart = ($cstart - 1) * $config["news_number"];
}
$sql_select = $Filter::sqlSelect() . $filterSqlWhere . " ORDER BY " . $Filter::$orderBy . " LIMIT " . $cstart . "," . $config["news_number"];
$tpl->is_custom = true;
include DLEPlugins::Check(ENGINE_DIR . "/modules/show.short.php");
if ($configVar["redirect_filter"] && !$vars["ajax"]) {
    $Filter::redirect($count_all);
}
if (!$news_found) {
    if ($configVar["code_filter"] == 404) {
        @header("HTTP/1.0 404 Not Found");
    }
    $tpl->load_template("info.tpl");
    $tpl->set("{error}", $langVar["site"]["not_found"]);
    $tpl->set("{title}", $langVar["site"]["info"]);
    $tpl->compile("content");
    $tpl->clear();
} else {
    if ($config["files_allow"] && strpos($tpl->result["content"], "[attachment=") !== false) {
        $tpl->result["content"] = show_attach($tpl->result["content"], $attachments);
    }
}
if (14 <= (double) $config["version_id"]) {
    $tpl->result["content"] = LazyDev\Filter\Filter::navigation();
}
unset($cat_info[$category_id]);
$category_id = false;
$Filter::$seoView->result["seo"] = $Conditions::realize($Filter::$seoView->result["seo"], $Filter::$filterData);
preg_match("'\\[meta-title\\](.*?)\\[/meta-title\\]'si", $Filter::$seoView->result["seo"], $metaTitle);
if ($metaTitle[1] != "") {
    $metatags["title"] = $metaTitle[1];
}
preg_match("'\\[meta-description\\](.*?)\\[/meta-description\\]'si", $Filter::$seoView->result["seo"], $metaTitle);
if ($metaTitle[1] != "") {
    $metatags["description"] = $metaTitle[1];
}
preg_match("'\\[meta-keywords\\](.*?)\\[/meta-keywords\\]'si", $Filter::$seoView->result["seo"], $metaTitle);
if ($metaTitle[1] != "") {
    $metatags["keywords"] = $metaTitle[1];
}
$metatags["keywords"] .= $Filter::metaRobots();
preg_match("'\\[meta-speedbar\\](.*?)\\[/meta-speedbar\\]'si", $Filter::$seoView->result["seo"], $metaTitle);
if ($metaTitle[1] != "") {
    $metatags["speedbar"] = $metaTitle[1];
}
$metatags = $Conditions::cleanArray($metatags);
if ($config["speedbar"] && $metatags["speedbar"]) {
    $tpl->load_template("lazydev/dle_filter/speedbar.tpl");
    $tpl->set("{site-name}", $config["short_title"]);
    $tpl->set("{site-url}", $config["http_home_url"]);
    $tpl->set("{separator}", $config["speedbar_separator"]);
    $tpl->set("{filter-name}", $metatags["speedbar"]);
    $tpl->set("{filter-url}", $url_page . "/");
    $tpl->set("{page-descr}", $lang["news_site"]);
    $tpl->set("{page}", $Filter::$pageFilter);
    if (1 < $Filter::$pageFilter) {
        $tpl->set_block("'\\[second\\](.*?)\\[/second\\]'si", "\\1");
        $tpl->set_block("'\\[first\\](.*?)\\[/first\\]'si", "");
    } else {
        $tpl->set_block("'\\[second\\](.*?)\\[/second\\]'si", "");
        $tpl->set_block("'\\[first\\](.*?)\\[/first\\]'si", "\\1");
    }
    $tpl->compile("speedbar");
    $tpl->clear();
    $config["speedbar"] = false;
}
if ($configVar["cache_filter"]) {
    $cacheArray = array("content" => $tpl->result["content"], "seo" => array("title" => $metatags["title"], "description" => $metatags["description"], "keywords" => $metatags["keywords"], "speedbar" => $tpl->result["speedbar"]), "navigation" => $tpl->result["navigation"], "url" => $Filter::$urlFilter, "id" => $filterID, "sqlQuery" => $sql_select, "foundNews" => intval($news_found), "countNews" => $count_all);
    $cacheArray = LazyDev\Filter\Helper::json($cacheArray);
    LazyDev\Filter\Cache::set($cacheArray, $filterID);
}
if ($configVar["statistics"] && $Filter::$pageFilter < 2) {
    $Filter::setStatistics(array("mysqlTime" => $db->MySQL_time_taken, "templateTime" => $tpl->template_parse_time, "foundNews" => intval($news_found), "queryNumber" => $db->query_num, "statistics" => $filterID, "sqlQuery" => $db->safesql($sql_select)));
}

?>